﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="AnchorPoints.Default" %>

<%@ Register Assembly="MindFusion.Diagramming.WebForms" Namespace="MindFusion.Diagramming.WebForms"
	TagPrefix="ndiag" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
	<title>MindFusion NetDiagram Sample - Anchor Points</title>
	<link href="common/jquery-ui.min.css" rel="stylesheet" />
	<link href="common/samples.css" rel="stylesheet" />
	<script type="text/javascript" src="common/jquery.min.js"></script>
	<script type="text/javascript" src="common/jquery-ui.min.js"></script>
	<script type="text/javascript" src="common/samples.js"></script>
</head>
<body>
	<form id="form1" runat="server">
	<asp:ScriptManager ID="ScriptManager1" runat="server" />
	<div id="header" style="height: 49px;">
		DefaultShape:
		<select id="selectShape" onchange="onShapeChanged(this.options[this.selectedIndex].value)">
			<option>Node</option>
			<option>Decision</option>
		</select>
		<div style="float: right; margin-right: 5px; margin-top: 17px;">
			<button id="expandButton" onclick="onExpandCollapse()">
				&gt;</button>
		</div>
	</div>
	<div id="info" style="top: 60px; bottom: 24px;">
		<div id="infoTab" style="padding: 10px;">
			<h1>
				About this sample</h1>
			<p>
				This sample shows how to define custom anchor patterns and assign them to diagram
				nodes. There are also several predefined anchor patterns to choose from. Link several
				nodes to get an idea how anchor points work.
			</p>
		</div>
	</div>
	<div id="content" style="top: 60px; bottom: 24px;">
		<ndiag:DiagramView ID="diagramView" runat="server" Style="position: absolute; left: 0px;
			top: 0px; right: 0px; bottom: 0px;" ClientSideMode="Canvas" NodeCreatedScript="onNodeCreated"
			Diagram-BackBrush="s:#ffffffff">
		</ndiag:DiagramView>
	</div>
	<div id="footer" style="height: 24px;">
		<span id="copyright"></span>
	</div>
	</form>
	<script type="text/javascript">

		Sys.Application.add_init(function (sender, args)
		{
			//define an anchor pattern
			var a1 = [];
			a1.push(new MindFusion.Diagramming.AnchorPoint(10, 0, true, false, MindFusion.Diagramming.MarkStyle.Circle, 'navy'));
			a1.push(new MindFusion.Diagramming.AnchorPoint(50, 0, true, false, MindFusion.Diagramming.MarkStyle.Circle, 'blue'));
			a1.push(new MindFusion.Diagramming.AnchorPoint(90, 0, true, false, MindFusion.Diagramming.MarkStyle.Circle, 'red'));
			a1.push(new MindFusion.Diagramming.AnchorPoint(10, 100, false, true, MindFusion.Diagramming.MarkStyle.Rectangle));
			a1.push(new MindFusion.Diagramming.AnchorPoint(50, 100, false, true, MindFusion.Diagramming.MarkStyle.Rectangle));
			a1.push(new MindFusion.Diagramming.AnchorPoint(90, 100, false, true, MindFusion.Diagramming.MarkStyle.Rectangle));

			var apat1 = new MindFusion.Diagramming.AnchorPattern(a1);
			apat1.setPatternId('pattern1');
		});

		function onShapeChanged(value)
		{
			var diagram = $find('diagramView');
			//change Diagram's default shape
			if (value == "Node")
			{
				diagram.setDefaultShape('RoundRect');
			}
			else
			{
				diagram.setDefaultShape('Decision');
			}
		}

		function onNodeCreated(sender, args)
		{
			var node = args.getNode();
			//set an anchor pattern depending on the node's shape
			if (node.getShape().getId() == "RoundRect")
			{
				node.setAnchorPattern(MindFusion.Diagramming.AnchorPattern.fromId("pattern1"));
			}
			else
			{
				node.setAnchorPattern(MindFusion.Diagramming.AnchorPattern.decision1In3Out);
			}
		}
	</script>
</body>
</html>
