﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using MindFusion.Diagramming.WebForms;
using MindFusion.Diagramming;
using System.Drawing;

namespace AnchorPoints
{
	public partial class Default : System.Web.UI.Page
	{
		protected void Page_Load(object sender, EventArgs e)
		{
			if (!IsPostBack)
			{
				Diagram diagram = diagramView.Diagram;
				diagram.RouteLinks = true;

				DiagramStyle style = new DiagramStyle();
				style.BackBrush = new MindFusion.Drawing.SolidBrush(Color.White);
				style.FontFamily = "Verdana";
				style.Brush = new MindFusion.Drawing.LinearGradientBrush(Color.LightGray, Color.DarkTurquoise, 30);
				style.ShadowBrush = new MindFusion.Drawing.SolidBrush(Color.Gray);
				diagram.Style = style;

				diagram.LinkHeadShapeSize = 3;
				diagram.ShowAnchors = ShowAnchors.Always;
				diagram.ShapeHandlesStyle = HandlesStyle.SquareHandles;
				diagram.ShowGrid = true;
				diagram.AlignToGrid = true;
				diagram.ShadowsStyle = ShadowsStyle.ZOrder;
				ShapeNode pb1, pb2, pb3, pb4, decb1, decb2;

				// Define some AnchorPattern objects.
				var apat1 = new AnchorPattern(new AnchorPoint[]
				{
					new AnchorPoint(50, 0, true, true),
					new AnchorPoint(100, 50, true, true),
					new AnchorPoint(50, 100, true, true),
					new AnchorPoint(0, 50, true, true)
				});

				var apat2 = AnchorPattern.FromId("pattern1");
				if (apat2 == null)
				{
					apat2 = new AnchorPattern(new AnchorPoint[]
				{
					new AnchorPoint(10, 0, true, false, MarkStyle.Circle, Color.RoyalBlue),
					new AnchorPoint(50, 0, true, false, MarkStyle.Circle, Color.Blue),
					new AnchorPoint(90, 0, true, false, MarkStyle.Circle, Color.Firebrick),
					new AnchorPoint(10, 100, false, true, MarkStyle.Rectangle),
					new AnchorPoint(50, 100, false, true, MarkStyle.Rectangle),
					new AnchorPoint(90, 100, false, true, MarkStyle.Rectangle)
				}, "pattern1");
				}

				// Create some ShapeNodes and assign an AnchorPattern to them.
				pb1 = new ShapeNode(diagram);
				pb1.Bounds = new RectangleF(10, 7, 25, 18);
				pb1.Shape = Shapes.Ellipse;
				pb1.Text = "Start";
				pb1.AnchorPattern = apat1;
				diagram.Nodes.Add(pb1);

				pb2 = new ShapeNode(diagram);
				pb2.Bounds = new RectangleF(20, 75, 25, 18);
				pb2.Text = "node 1";
				pb2.AnchorPattern = apat2;
				diagram.Nodes.Add(pb2);

				pb3 = new ShapeNode(diagram);
				pb3.Bounds = new RectangleF(70, 70, 25, 18);
				pb3.Text = "node 2";
				pb3.AnchorPattern = apat2;
				diagram.Nodes.Add(pb3);

				pb4 = new ShapeNode(diagram);
				pb4.Bounds = new RectangleF(80, 100, 25, 18);
				pb4.Shape = Shapes.Ellipse;
				pb4.Text = "End";
				pb4.AnchorPattern = apat1;
				diagram.Nodes.Add(pb4);

				decb1 = new ShapeNode(diagram);
				decb1.Bounds = new RectangleF(20, 35, 30, 20);
				decb1.Shape = Shapes.Decision;
				decb1.Text = "check 1";
				decb1.AnchorPattern = AnchorPattern.Decision1In3Out;
				diagram.Nodes.Add(decb1);

				decb2 = new ShapeNode(diagram);
				decb2.Bounds = new RectangleF(70, 30, 30, 20);
				decb2.Shape = Shapes.Decision;
				decb2.Text = "check 2";
				decb2.AnchorPattern = AnchorPattern.Decision2In2Out;
				diagram.Nodes.Add(decb2);

				// Connect two of the nodes with a link.
				DiagramLink link = new DiagramLink(diagram, decb1, decb2);
				link.AutoRoute = true;
				diagram.Links.Add(link);
			}
		}
	}
}